/*
 * FrameNumberFinder.java
 *
 * Created on 2 czerwiec 2008, 12:54
 */

package mt.mas.sampleapplication.gui;

import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import mt.mas.sampleapplication.data.NumberCounter;

/**
 *
 * @author  mariuszadmin
 */
public class FrameNumberCounter extends javax.swing.JInternalFrame {
    List<Integer> numbers = null;
    
    /** Creates new form FrameNumberFinder */
    public FrameNumberCounter(List<Integer> numbers) {
        initComponents();
        
        this.numbers = numbers;
        lblListSize.setText(Integer.toString(numbers.size()));
    }

    private void count() {
        if(numbers == null || numbers.size() < 1) {
            JOptionPane.showInternalMessageDialog(this, "Nie wygenerowano listy liczb!");
            return;
        }
        
        NumberCounter counter = new NumberCounter(numbers, Integer.parseInt(txtNumberToCount.getText()));
        counter.start();
        
        if(counter.isCancelled()) {
            JOptionPane.showInternalMessageDialog(this, "Operacja anulowana!");            
        }
        else {
            try {
                Integer result = counter.get();
                JOptionPane.showInternalMessageDialog(this, "Naliczono "  + result + " wystapien liczby " + txtNumberToCount.getText());            

            } catch (InterruptedException ex) {
                Logger.getLogger(FrameNumberCounter.class.getName()).log(Level.SEVERE, null, ex);
            } catch (ExecutionException ex) {
                Logger.getLogger(FrameNumberCounter.class.getName()).log(Level.SEVERE, null, ex);
            }
            
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        txtNumberToCount = new javax.swing.JTextField();
        btnCancel = new javax.swing.JButton();
        btnCount = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        lblListSize = new javax.swing.JLabel();

        jLabel1.setText("Liczba do wyszukania");

        txtNumberToCount.setText("100");

        btnCancel.setText("Anuluj");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnCount.setText("Licz");
        btnCount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCountActionPerformed(evt);
            }
        });

        jLabel2.setText("Rozmiar listy");

        lblListSize.setText("#");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(105, Short.MAX_VALUE)
                .addComponent(btnCount)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnCancel)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblListSize)
                    .addComponent(txtNumberToCount, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtNumberToCount, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(lblListSize))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 13, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancel)
                    .addComponent(btnCount))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
    this.setVisible(false);
}//GEN-LAST:event_btnCancelActionPerformed

private void btnCountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCountActionPerformed
    count();
}//GEN-LAST:event_btnCountActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnCount;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel lblListSize;
    private javax.swing.JTextField txtNumberToCount;
    // End of variables declaration//GEN-END:variables

}
